package org.uoc.petrel;

import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.Button;

public class Petrel extends Activity {
	
	private PetrelDBAdapter datasource;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_petrel);

		datasource = new PetrelDBAdapter(this);
	    datasource.open();
	    
	    // If we don't have tickers, populate the default values
	    List<Ticker> tickers = datasource.getAllTickers();
	    if (tickers.size() == 0)
	    	datasource.populateDefaultTickers();
	    
	    Button btnPortfolio = (Button) findViewById(R.id.UpdateTickers);
	    Button btnTicker = (Button) findViewById(R.id.button2);
	    
	    btnPortfolio.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                Intent PortfolioScreen = new Intent(getApplicationContext(), PortfolioActivity.class);
                startActivity(PortfolioScreen);
            }
        });
	    
	    btnTicker.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                Intent TickerScreen = new Intent(getApplicationContext(), TickerActivity.class); 
                startActivity(TickerScreen); 
            }
        });
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.petrel, menu);
		return true;
	}	
}
