package org.uoc.petrel;

import java.util.Timer;
import java.util.TimerTask;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

public class PetrelService extends Service {
	
	private Timer timer = new Timer();
	private void startService()
	{
		timer.scheduleAtFixedRate( new TimerTask()
		{
			public void run()
			{
				updateTickers();
			}
		}, 0, 300000); // 5 minutes
	}
	private void stopService()
	{
		if (timer != null)
			timer.cancel();
	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		return null;
	}
	
	@Override
	public void onCreate()
	{
		super.onCreate();
		this.startService();
		Log.v("Petrel", "PetrelService Created");
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId)
	{
		Log.v("Petrel", "PetrelService onStartCommand");
		return START_STICKY;
	}

	@Override
	public void onDestroy()
	{
		super.onDestroy();
		this.stopService();
		Log.v("Petrel", "PetrelService Destroyed");
	}
	
	// Tickers
	private void updateTickers()
	{
		
	}	
}

