package org.uoc.petrel;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class Portfolio {
	private long id;
	private String name;
	private double mu;
	private double sigma;
	private double rho;
	private List<Asset> assets;

	public Portfolio() {
		this.assets = new ArrayList<Asset>();
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public double getMu() {
		return mu;
	}

	public void setMu(double mu) {
		this.mu = mu;
	}

	public double getSigma() {
		return sigma;
	}

	public void setSigma(double sigma) {
		this.sigma = sigma;
	}

	public double getRho() {
		return rho;
	}

	public void setRho(double rho) {
		this.rho = rho;
	}

	public List<Asset> getAssets() {
		return assets;
	}

	public void addAsset(Asset asset) {
		this.assets.add(asset);
	}

	public boolean removeAsset(Asset asset) {
		return this.assets.remove(asset);
	}

	@Override
	public String toString() {
		return name;
	}

	public String toJSON() {
		JSONObject jsonObject = new JSONObject();
		try {

			jsonObject.put("id", this.getId());
			jsonObject.put("name", this.getName());
			jsonObject.put("mu", this.getMu());
			jsonObject.put("sigma", this.getSigma());
			jsonObject.put("rho", this.getRho());
			
			JSONArray jsArray = new JSONArray(this.assets);
			jsonObject.put("assets", jsArray);
			
			return jsonObject.toString();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "";
		}
	}
}
