package org.uoc.petrel;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class PortfolioEditActivity extends Activity {
	private PetrelDBAdapter datasource;

	private Spinner spinnerAsset1, spinnerAsset2, spinnerAsset3, spinnerAsset4,
			spinnerAsset5;
	private EditText editTextName, editTextPercent1, editTextPercent2,
			editTextPercent3, editTextPercent4, editTextPercent5;

	private Button btnOptimize, btnSave, btnBack;
	private Portfolio portfolio = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_portfolio_edit);

		datasource = new PetrelDBAdapter(this);
		datasource.open();

		List<Ticker> tickers = datasource.getAllTickers();

		// Fill up list for spinners
		List<String> list = new ArrayList<String>();
		list.add("None selected");

		for (int i = 0; i < tickers.size(); i++)
			list.add(tickers.get(i).getName());

		ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, list);
		dataAdapter
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		// Add items to spinners
		spinnerAsset1 = (Spinner) findViewById(R.id.spinnerAsset1);
		spinnerAsset1.setAdapter(dataAdapter);

		spinnerAsset2 = (Spinner) findViewById(R.id.spinnerAsset2);
		spinnerAsset2.setAdapter(dataAdapter);

		spinnerAsset3 = (Spinner) findViewById(R.id.spinnerAsset3);
		spinnerAsset3.setAdapter(dataAdapter);

		spinnerAsset4 = (Spinner) findViewById(R.id.spinnerAsset4);
		spinnerAsset4.setAdapter(dataAdapter);

		spinnerAsset5 = (Spinner) findViewById(R.id.spinnerAsset5);
		spinnerAsset5.setAdapter(dataAdapter);

		// Buttons
		btnOptimize = (Button) findViewById(R.id.buttonOptimize);
		btnSave = (Button) findViewById(R.id.buttonSave);
		btnBack = (Button) findViewById(R.id.buttonBack);

		// EditTexts
		editTextName = (EditText) findViewById(R.id.editTextName);
		editTextPercent1 = (EditText) findViewById(R.id.editTextPercent1);
		editTextPercent2 = (EditText) findViewById(R.id.editTextPercent2);
		editTextPercent3 = (EditText) findViewById(R.id.editTextPercent3);
		editTextPercent4 = (EditText) findViewById(R.id.editTextPercent4);
		editTextPercent5 = (EditText) findViewById(R.id.editTextPercent5);

		btnOptimize.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				savePortfolio();
				optimize_portfolio();
				Toast.makeText(getApplicationContext(),
						"The portfolio has been optimized", Toast.LENGTH_SHORT)
						.show();
			}
		});

		btnSave.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				savePortfolio();
				Toast.makeText(getApplicationContext(),
						"The portfolio has been saved", Toast.LENGTH_SHORT)
						.show();
			}
		});

		btnBack.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				finishActivity(0);
			}
		});
	}

	private void savePortfolio() {
		if (portfolio == null && !editTextName.getText().toString().isEmpty()) {
			portfolio = datasource.createPortfolio(editTextName.getText()
					.toString());
		}

		String asset1Name = spinnerAsset1.getSelectedItem().toString();
		String asset2Name = spinnerAsset1.getSelectedItem().toString();
		String asset3Name = spinnerAsset1.getSelectedItem().toString();
		String asset4Name = spinnerAsset1.getSelectedItem().toString();
		String asset5Name = spinnerAsset1.getSelectedItem().toString();

		String asset1W = editTextPercent1.getText().toString();
		String asset2W = editTextPercent2.getText().toString();
		String asset3W = editTextPercent3.getText().toString();
		String asset4W = editTextPercent4.getText().toString();
		String asset5W = editTextPercent5.getText().toString();

		if (!asset1Name.isEmpty() && !asset1Name.equals("None selected")) {
			Asset asset = datasource.createAsset(asset1Name);
			if (!asset1W.isEmpty())
				asset.setW(Double.parseDouble(asset1W));
			datasource.addAssetToPortfolio(asset, portfolio);
			portfolio.addAsset(asset);
		}

		if (!asset2Name.isEmpty() && !asset2Name.equals("None selected")) {
			Asset asset = datasource.createAsset(asset2Name);
			if (!asset2W.isEmpty())
				asset.setW(Double.parseDouble(asset2W));
			datasource.addAssetToPortfolio(asset, portfolio);
			portfolio.addAsset(asset);
		}

		if (!asset3Name.isEmpty() && !asset3Name.equals("None selected")) {
			Asset asset = datasource.createAsset(asset3Name);
			if (!asset3W.isEmpty())
				asset.setW(Double.parseDouble(asset3W));
			datasource.addAssetToPortfolio(asset, portfolio);
			portfolio.addAsset(asset);
		}

		if (!asset4Name.isEmpty() && !asset4Name.equals("None selected")) {
			Asset asset = datasource.createAsset(asset4Name);
			if (!asset4W.isEmpty())
				asset.setW(Double.parseDouble(asset4W));
			datasource.addAssetToPortfolio(asset, portfolio);
			portfolio.addAsset(asset);
		}

		if (!asset5Name.isEmpty() && !asset5Name.equals("None selected")) {
			Asset asset = datasource.createAsset(asset5Name);
			if (!asset5W.isEmpty())
				asset.setW(Double.parseDouble(asset5W));
			datasource.addAssetToPortfolio(asset, portfolio);
			portfolio.addAsset(asset);
		}
	}

	private void optimize_portfolio() {
		// Exemple de query:
		// {
		// 'name': 'portfolio1',
		// 'mu': 0,
		// 'sigma': 0,
		// 'rho': 0,
		// 'assets': 'SAN.MC BME.MC CABK.MC'
		// }
		StringBuilder assets = new StringBuilder();
		for (int i = 0; i < portfolio.getAssets().size(); i++)
			assets.append(portfolio.getAssets().get(i).getName());

		HttpClient httpclient = new DefaultHttpClient();
		HttpPost httppost = new HttpPost("http://api.corrius.org/portfolio/");

		try {
			// Add your data
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
			nameValuePairs.add(new BasicNameValuePair("name", portfolio
					.getName()));
			nameValuePairs.add(new BasicNameValuePair("mu", String
					.valueOf(portfolio.getMu())));
			nameValuePairs.add(new BasicNameValuePair("sigma", String
					.valueOf(portfolio.getSigma())));
			nameValuePairs.add(new BasicNameValuePair("rho", String
					.valueOf(portfolio.getRho())));
			nameValuePairs.add(new BasicNameValuePair("assets", assets
					.toString()));
			httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

			// Execute HTTP Post Request
			HttpResponse response = httpclient.execute(httppost);

			// Exemple de resposta:
			// {
			// "name": "portfolio1",
			// "mu": 10.822,
			// "rho": "0",
			// "sigma": 0.30822070014844882,
			// "assets": {
			// "BME.MC": 0.32604957922945615,
			// "SAN.MC": 0.67395042077054379,
			// "CABK.MC": 0.0
			// }
			// }
			JSONObject json = new JSONObject(response.toString());
			portfolio.setMu(json.getDouble("mu"));
			portfolio.setSigma(json.getDouble("sigma"));
			portfolio.setSigma(json.getDouble("rho"));
			JSONArray json_assets = json.getJSONArray("assets");

			for (int i = 0; i < portfolio.getAssets().size(); i++) {
				Asset asset = portfolio.getAssets().get(i);
				asset.setW(json_assets.getDouble(i));
			}

			if (portfolio.getAssets().get(0) != null)
				editTextPercent1.setText(String.valueOf(portfolio.getAssets()
						.get(0).getW()));
			if (portfolio.getAssets().get(1) != null)
				editTextPercent2.setText(String.valueOf(portfolio.getAssets()
						.get(1).getW()));
			if (portfolio.getAssets().get(2) != null)
				editTextPercent3.setText(String.valueOf(portfolio.getAssets()
						.get(2).getW()));
			if (portfolio.getAssets().get(3) != null)
				editTextPercent4.setText(String.valueOf(portfolio.getAssets()
						.get(3).getW()));
			if (portfolio.getAssets().get(4) != null)
				editTextPercent5.setText(String.valueOf(portfolio.getAssets()
						.get(4).getW()));

		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
		} catch (IOException e) {
			// TODO Auto-generated catch block
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
