package org.uoc.petrel;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class PortfolioListAdapter extends BaseAdapter {

	private List<Portfolio> listData;

	private LayoutInflater layoutInflater;

	public PortfolioListAdapter(Context context, List<Portfolio> portfolios) {
		this.listData = portfolios;
		layoutInflater = LayoutInflater.from(context);
	}

	@Override
	public int getCount() {
		return listData.size();
	}

	@Override
	public Object getItem(int position) {
		return listData.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder;
		if (convertView == null) {
			convertView = layoutInflater.inflate(
					R.layout.activity_portfolio_list, null);
			holder = new ViewHolder();
			holder.nameView = (TextView) convertView.findViewById(R.id.name);
			holder.muView = (TextView) convertView.findViewById(R.id.mu);
			holder.sigmaView = (TextView) convertView.findViewById(R.id.sigma);
			holder.rhoView = (TextView) convertView.findViewById(R.id.rho);
			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}

		holder.nameView.setText(listData.get(position).getName());
		holder.muView.setText("Mu: " + listData.get(position).getMu() + " ");
		holder.sigmaView.setText("Sigma: " + listData.get(position).getSigma()
				+ " ");
		holder.rhoView.setText("Rho: " + listData.get(position).getRho() + " ");
		return convertView;
	}

	private static class ViewHolder {
		TextView nameView;
		TextView muView;
		TextView sigmaView;
		TextView rhoView;
	}

}
