package org.uoc.petrel;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONObject;

import android.app.ListActivity;
import android.os.Bundle;
import android.os.StrictMode;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Toast;

public class TickerActivity extends ListActivity {

	private PetrelDBAdapter datasource;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_ticker);

		datasource = new PetrelDBAdapter(this);
		datasource.open();

		List<Ticker> tickers = datasource.getAllTickers();

		ArrayAdapter<Ticker> dataAdapter = new ArrayAdapter<Ticker>(this,
				android.R.layout.simple_list_item_1, tickers);
		setListAdapter(dataAdapter);

		Button btnUpdateTickers = (Button) findViewById(R.id.UpdateTickers);

		btnUpdateTickers.setOnClickListener(new View.OnClickListener() {
			public void onClick(View arg0) {

				StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder()
						.permitAll().build();
				StrictMode.setThreadPolicy(policy);

				StringBuilder builder = new StringBuilder();
				HttpClient client = new DefaultHttpClient();
				HttpGet httpGet = new HttpGet("http://api.corrius.org/tickers");
				try {
					HttpResponse response = client.execute(httpGet);
					StatusLine statusLine = response.getStatusLine();
					int statusCode = statusLine.getStatusCode();
					if (statusCode == 200) {
						HttpEntity entity = response.getEntity();
						InputStream content = entity.getContent();
						BufferedReader reader = new BufferedReader(
								new InputStreamReader(content));
						String line;
						while ((line = reader.readLine()) != null) {
							builder.append(line);
						}
					} else {
						Log.e(TickerActivity.class.toString(),
								"Failed to download file");
					}
				} catch (ClientProtocolException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}

				try {
					JSONArray jsonArray = new JSONArray(builder.toString());
					Log.i(TickerActivity.class.getName(), "Number of entries "
							+ jsonArray.length());
					for (int i = 0; i < jsonArray.length(); i++) {
						JSONObject jsonObject = jsonArray.getJSONObject(i);
						Log.i(TickerActivity.class.getName(),
								jsonObject.getString("name"));
						Ticker ticker = new Ticker();
						ticker.setName(jsonObject.getString("name"));
						ticker.setCompany(jsonObject.getString("company"));
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				
				Toast.makeText(getApplicationContext(),
						"The tickers are updated", Toast.LENGTH_SHORT).show();
			}
		});
	}
}
