from piston.handler import BaseHandler
from petrel.api.models import Ticker, Portfolio, Asset
from petrel.api.utils import optimize_portfolio

class TickerHandler(BaseHandler):
    allowed_methods = ('GET',)
    model = Ticker

    def read(self, request):
        base = Ticker.objects
        return base.all()

class PortfolioHandler(BaseHandler):
    allowed_methods = ('POST',)
    model = Portfolio
    
    def create(self, request):
        if request.POST:
            portfolio = Portfolio()
            portfolio.name = request.POST.get("name")
            portfolio.mu = request.POST.get("mu")
            portfolio.sigma = request.POST.get("sigma")
            portfolio.rho = request.POST.get("rho")
            portfolio.assets = request.POST.get("assets")
            portfolio.save()
            
            tickers = [a for a in portfolio.assets.split()]
            weights, variance, ret = optimize_portfolio(tickers)
            portfolio.mu = ret
            portfolio.sigma = variance
            portfolio.assets = weights
            portfolio.save()
            return portfolio
            

              
            
        
