from django.db import models
from datetime import datetime

# Create your models here.
class Ticker(models.Model):
    name = models.CharField(max_length=10)
    company = models.CharField(max_length=100)

class TickerData(models.Model):
    date = models.DateField()
    name = models.CharField(max_length=10)
    price = models.DecimalField(max_digits=5, decimal_places=2)

class Asset(models.Model):
    name = models.CharField(max_length=10)
    w = models.DecimalField(max_digits=5, decimal_places=2)
    mu = models.DecimalField(max_digits=5, decimal_places=2)
    sigma = models.DecimalField(max_digits=5, decimal_places=2)

class Portfolio(models.Model):
    name = models.CharField(max_length=10)
    mu = models.DecimalField(max_digits=5, decimal_places=2)
    sigma = models.DecimalField(max_digits=5, decimal_places=2)
    rho = models.DecimalField(max_digits=5, decimal_places=2)
    assets = models.CharField(max_length=100)
    
