#!/usr/bin/env python

import ystockquote
import datetime as dt
import time

from urllib2 import HTTPError
from django.core.management import setup_environ

import settings
setup_environ(settings)

from api.models import TickerData

if hasattr(dt.datetime, 'strptime'):
    #python 2.6
    strptime = dt.datetime.strptime
else:
    #python 2.4 equivalent
    strptime = lambda date_string, format: dt.datetime(*(time.strptime(date_string, format)[0:6]))

TICKERS = [
"ABG.MC",
"ABE.MC",
"ANA.MC",
"ACX.MC",
"ACS.MC",
"AMS.MC",
"MTS.MC",
"POP.MC",
"SAB.MC",
"SAN.MC",
"BKT.MC",
"BBVA.MC",
"BME.MC",
"CABK.MC",
"DIA.MC",
"ENG.MC",
"ELE.MC",
"FCC.MC",
"FER.MC",
"GAS.MC",
"GRF.MC",
"IAG.MC",
"IBE.MC",
"ITX.MC",
"IDR.MC",
"JAZ.MC",
"MAP.MC",
"TL5.MC",
"OHL.MC",
"REE.MC",
"REP.MC",
"SYV.MC",
"TRE.MC",
"TEF.MC",
"VIS.MC",
]

def get_historical_prices(ticker, start, end):
    series = ystockquote.get_historical_prices(ticker, start, end)
    for element in series:
        if element[0] == 'Date':
            continue

        t = TickerData(date=strptime((element[0]), "%Y-%m-%d"), 
                   name=ticker, 
                   price=element[6])
        t.save()
        

for ticker in TICKERS:
    start = "2012-01-01"
    now = dt.datetime.now()
    end = now.strftime("%Y-%m-%d")

    try:
        get_historical_prices(ticker, start, end)
        print "INFO: Ticker %s updated" % ticker
        time.sleep(1)
    except HTTPError:
        print "ERROR: Ticker %s not found!" % ticker
        break
    
